\documentclass[aspectratio=169]{beamer}
\usepackage[version=3]{mhchem}
\usepackage{tikz}

\usepackage{adjustbox}
\usepackage{color}
\usepackage{xcolor}
\usepackage{amssymb}
\usepackage{amsmath}
\usetikzlibrary{positioning,fit,backgrounds,graphs,shapes.misc}

\usepackage[style=verbose,backend=biber]{biblatex}
\addbibresource{library.bib}

\usetheme{metropolis}           % Use metropolis theme

% \tikzset{%
%   scale=0.1,
%   transform shape,
%   node distance=4em,
%   grey_node/.style={
%     transform shape,
%     rounded rectangle,minimum size=2.0em,
%     very thick,draw=black!50, inner sep=0.3em, outer sep=0.2em,
%     top color=white, bottom color=black!20
%   },
%   red_node/.style={
%     transform shape,
%     rounded rectangle,minimum size=2.0em,
%     very thick,draw=red!50, inner sep=0.3em, outer sep=0.2em,
%     top color=white, bottom color=red!20
%   },
%   blue_node/.style={
%     transform shape,
%     rounded rectangle,minimum size=2.0em,
%     very thick,draw=blue!50, inner sep=0.3em, outer sep=0.2em,
%     top color=white, bottom color=blue!20
%   },
%   tf/.style={
%     very thick,
%   },
%   ma/.style={
%     very thick,
%     color = black!60
%   },
% }

% \title{It's about time: An alternative approach for
%   reductionist modelling of linear pathways in
% systems biology (and how it is relevant for FLS2)}
% \date{\today}


\begin{document}

\begin{frame}{title}
    
\end{frame}

\begin{frame}{Biology is complicated}
    \begin{center}
    \includegraphics[height=0.9\textheight]{images/Human_Metabolism_-_Pathways.jpg}

    \vspace{-4mm}
    \footnotesize{Evans Love, CC BY-SA 4.0}
    \end{center}
\end{frame}

\begin{frame}{Systems biology - getting things to make sense using mathematical modelling}
    \begin{center}
    \begin{tikzpicture}
        \node (obs) at (0, 2) {Observation};
        \node (hyp) at (-2, 0) {Hypothesis}
        edge[<-] (obs);
        \node (model) at (2, 0) {Model}
        edge[<-] (hyp)
        edge[->] (obs);
    \end{tikzpicture}
    \end{center}
    Modelling to "deduce" consequences of hypotheses such that they can be compared with observations.
\end{frame}

\begin{frame}{Mathematical models}
    Machines to deduce consequences from assumptions \footcite{gunawardena2014}.
    
    \pause
    But what assumptions?
    \pause
    \begin{itemize}
        \item Hypothesis-related
            \begin{itemize}
                \item[] What causes what?
            \end{itemize}
    \pause
        \item Mathematical plumbing
            \begin{itemize}
                \item[] Continuous deterministic? 
            \end{itemize}
    \pause
        \item Simplications
        \begin{itemize}
            \item[] Simplified representations of common interactions
            \item[] What to include, what to ignore?
        \end{itemize}
    \end{itemize}


%     \small
%   \begin{itemize}
%     \setlength\itemsep{2mm}
%   \item[What?] A mathematical representation of an hypothesis.
%   \item[Goal?] To evaluate validity and consequences of the hypothesis.
%   \item[How?] Deduction from assumptions.
%     \small
%     \begin{itemize}
%       \setlength\itemsep{3mm}
%       \vspace{3mm}

%     \item Hypothesis assumptions:
%       \begin{itemize}
%         \item \ce{A -> B}.
%       \end{itemize}
%     \item Supporting assumptions:
%       \begin{itemize}
%         \item Deterministic/Stochastic,
%         \item Continuous/Discrete,
%         \item \ce{A ->[$V \cdot \frac{A^n}{K^n + A^n}$] B},
%         \item Parameter values,
%         \item Initial conditions.
%       \end{itemize}
%   \end{itemize}
% \item[Worry:] Reject hypothesis due to bad supporting assumption.
%   \end{itemize}

\end{frame}

  
  \begin{frame}[t]{Linear multi-step pathways - ubiquitous}
    
    \begin{align*}
      \ce{X_1 &->  X_2 -> $\ldots$ -> X_n} \\
      \\
      \frac{dX_i}{dt} &= \alpha_i \cdot X_{i-1} - \beta_i \cdot X_i
    \end{align*}
  
    \begin{columns}
        \begin{column}[]{0.5\textwidth}
    \begin{itemize}
      \setlength\itemsep{3mm}
    \item Intracellular signalling pathways,
      \begin{itemize}
        \setlength\itemsep{3mm}
        \vspace{2mm}
      \item Sensory systems,
      \item Kinase cascades,
      \item Metabolic pathways,
      \item Phosphotransfer chains,
    \end{itemize}
    \end{itemize}
        \end{column}
        \begin{column}[]{0.5\textwidth}
      \begin{itemize}
  \item Synthesis,
  \item Transport.
    \end{itemize}
            
        \end{column}
    \end{columns}
  \end{frame}
  
  \begin{frame}[t]{Simplifying linear pathways}
      \[\textrm{\textbf{Reality: }} \ce{Input -> X_1 ->  X_2 -> $\ldots$ -> X_n -> Output}\]
      \vspace{-4mm}
      \pause
      \begin{itemize}
          \item Most common simplification: Ignoring most steps
      \end{itemize}
      \[\textrm{\textbf{Model: }} \ce{Input -> X_1 ->  X_2 -> Output} \]
  
      \pause
      \begin{center}
        \includegraphics[height=0.5\textheight]{images/two_step.pdf}
      \end{center}
  \end{frame}
  


\begin{frame}{}
    \begin{center}
        \begin{tikzpicture}
            \foreach \i in {1,...,5}{
            \node<\i> [
                above right,
                inner sep=0] (image) at (0,0) {\includegraphics[width=\textwidth]{images/two_node_cost_\i.png}};
            }
            \begin{scope}[x={(image.south east)}, y={(image.north west)}]
                \draw<2->[->, very thick] (0.16,0.45) -- (0.25, 0.75); 
                \draw<3->[->, very thick] (0.95,0.62) -- (0.85, 0.75); 
                \draw<4->[->, very thick] (0.45,0.5) -- (0.25, 0.25); 
                \draw<5->[->, very thick] (0.45,0.61) -- (0.75, 0.25); 
            \end{scope}
        \end{tikzpicture}
        % \includegraphics[width=\textwidth]{images/two_step_cost.pdf}
    \end{center}
    

\end{frame}

\begin{frame}{Characterising the output dynamic}
      \[\ce{Input -> X_1 ->[$r_1$]  X_2 ->[$r_2$] $\ldots$ -> X_n ->[$r_n$] Output}\]

      \begin{columns}
          
          \begin{column}[]{0.6\textwidth}
              
    \begin{itemize}
        \item $\tau$ - the \textcolor{blue}{mean delay} from input to output.
        \[\tau \equiv \frac{\int_0^\infty t X_n(t) dt}{\int_0^\infty X_n(t) dt} = \sum_{i=1}^n \frac{1}{r_i}\]
        \item $\sigma$ - the \textcolor{red}{standard deviation} of that delay.
        \[\sigma \equiv \sqrt{\frac{\int_0^\infty t^2 X_n(t) dt}{\int_0^\infty X_n(t) dt} - \tau^2} = \sqrt{\sum_{i=1}^n \frac{1}{r_i^2}} \]
        % \vspace{-8mm}
        \item $s = \frac{\sigma}{\tau}$ - peak "sharpness".
    \end{itemize}
          \end{column}
          \begin{column}[]{0.4\textwidth}
              \includegraphics[width=\textwidth]{images/mean_std.png}
          \end{column}
      \end{columns}
\end{frame}

\begin{frame}
    \Large{\[1 \leq s \leq \sqrt{n}\]}
    \only<1-2>{\onslide<2>{\includegraphics[width=0.5\textwidth]{images/sharpness_1.png}}}
    \only<3>{\includegraphics[width=0.5\textwidth]{images/sharpness_2.png}}%
    \only<4->{\includegraphics[width=0.5\textwidth]{images/sharpness_3.png}}%
    ~\only<5->{\includegraphics[width=0.5\textwidth]{images/sharpness_dispersion.png}}
    
    \uncover<6->{
    \begin{center}
\Large{$ r_i = r_j \quad \forall i, j $ often optimal!}
    \end{center}}
\end{frame}

\begin{frame}{Alternative simplification - tunable pathway length, fixed rates}
    \begin{itemize}
        \item let pathway length, $n$, be a free parameter.
        \item assume $r_i = r \quad \forall i$.
        \item Three parameters - scaling $\gamma$; rate $r$; pathway length $n$.
    \end{itemize}
    \begin{align*}
        \frac{dx_1}{dt} &= r \cdot \left( \gamma \cdot input(t) - x_1 \right) \\
        \frac{dx_i}{dt} &= r \cdot \left( x_{i-1} - x_i \right) \quad \forall i \in {2, ..., n}\\
        x_i(0) &= 0 \quad \forall i
        \end{align*}
    has a nice solution:
        \begin{align*}
    \vspace{-5mm}
       x_n(t|\gamma, r, n) &= \gamma \cdot input(t) * \underbrace{g(t| r, n)}_{\textrm{Erlang PDF}}
    \end{align*}
    
    $\Rightarrow$ Erlang-distributed delay!
    
    (generalises to Gamma-distributed delay)

\end{frame}

\begin{frame}
    Identical rates might not be true - but is the assumption still useful?

    \pause
    
    % \begin{center}
    \includegraphics[width = 0.5\textwidth]{images/fixed_rate_demo.png}%
    \pause ~ \includegraphics[width = 0.5\textwidth]{images/fixed_rate_cost.png}%
    
    \vspace{-5mm}
    \pause Yes!
    % \end{center}
\end{frame}

% \begin{frame}{Fixed-rate assumption $\to$ Erlang-distributed delay}
    
%     \begin{align}
%         \frac{dx_1}{dt} &= r \cdot \left( \gamma \cdot input(t) - x_1 \right) \\
%         \frac{dx_i}{dt} &= r \cdot \left( x_{i-1} - x_i \right) \quad \forall i \in {2, ..., n}\\
%         x_i(0) &= 0 \quad \forall i
%     \end{align}

%     can be solved and gives:

%     \vspace{-5mm}
%     \begin{align}
%        x_n(t) = \gamma \cdot input(t) * g(t) 
%     \end{align}
    
%     \begin{itemize}
%         \item $\gamma$ scaling factor,
%         \item $*$ convolution,
%         \item $g(t)$ PDF of the Erlang distribution.
%     \end{itemize}
    
%     $\Rightarrow$ Erlang-distributed delay!
% \end{frame}

\begin{frame}{Works with any input}
    \begin{center}
   \includegraphics[width=\textwidth]{images/fixed_rate_multi_input.png} 
    \end{center}
\end{frame}

\begin{frame}{Distributed delays!}
    \begin{itemize}
        \item High-fidelity simplification of linear multi-step reactions.
    \end{itemize}
    
    \pause
    Why so uncommon? 

    \begin{itemize}
    \pause
        \item Awareness
    \pause
        \item Tooling
        \begin{itemize}
            \item DifferentialEquations.jl
    \pause
            \item ModelingToolkit.jl (coming soon)
            \item Catalyst.jl (coming soon)
            \item Pumas.jl (coming soon)
        \end{itemize}
    \end{itemize}
\end{frame}

\begin{frame}{Acknowledgements}
    \begin{itemize}
        \item Henrik Jönsson (PhD supervisor)
        \item Torkel Loman
            \item DifferentialEquations.jl
            \item BlackBoxOptim.jl
            \item Plots.jl 
    \end{itemize}
    
\end{frame}

\end{document}